diff -crN nakedmudv1.5/src/mud.h nakedmudv2.0/src/mud.h
*** nakedmudv1.5/src/mud.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/mud.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,39 ****
  
  
  //*****************************************************************************
! //
! // if you've installed a new module, you  need to put a define in here to let
  // the rest of the MUD know that you've installed the module.
- //
  //*****************************************************************************
! #define MODULE_OLC
! #define MODULE_TIME
  #define MODULE_SCRIPTS
- #define MODULE_ALIAS
  #define MODULE_CHAR_VARS
  #define MODULE_SOCIALS
  #define MODULE_HELP
  
  
  
  //*****************************************************************************
  //
! // To avoid having to write some bulky structure names, we've typedefed a
  // bunch of shortforms for commonly used datatypes. If you make a new datatype
  // that is used lots, put a typedef for it in here.
  //
--- 16,45 ----
  
  
  //*****************************************************************************
! // if you've installed a newmodule, you  need to put a define in here to let
  // the rest of the MUD know that you've installed the module.
  //*****************************************************************************
! 
! // mandatory modules. These are modules that the NakedMud core REQUIRES to run.
! // They have simply been made modules for organizational ease.
! #define MODULE_ITEMS
! #define MODULE_OLC2
  #define MODULE_SCRIPTS
  #define MODULE_CHAR_VARS
+ #define MODULE_SET_VAL
+ #define MODULE_EDITOR
+ 
+ // here is where your optional modules will go
+ #define MODULE_ALIAS
  #define MODULE_SOCIALS
  #define MODULE_HELP
+ #define MODULE_TIME
  
  
  
  //*****************************************************************************
  //
! // To avoid having to write some bulky structure names, we've typedef'd a
  // bunch of shortforms for commonly used datatypes. If you make a new datatype
  // that is used lots, put a typedef for it in here.
  //
***************
*** 41,63 ****
  typedef struct socket_data                SOCKET_DATA;
  typedef struct char_data                  CHAR_DATA;  
  typedef struct lookup_data                LOOKUP_DATA;
- typedef struct list                       LIST;
- typedef struct list_iterator              LIST_ITERATOR;
- typedef struct hashtable                  HASHTABLE;
- typedef struct hashtable_iterator         HASH_ITERATOR;
- typedef struct hashmap                    HASHMAP;
- typedef struct map_iterator               MAP_ITERATOR;
- typedef struct set_data                   SET;
- typedef struct set_iterator               SET_ITERATOR;
  typedef struct datatable                  DATATABLE;
  typedef struct storage_set                STORAGE_SET;
  typedef struct storage_set_list           STORAGE_SET_LIST;
  
- typedef struct property_table             PROPERTY_TABLE;
- typedef struct property_table_iterator    PROPERTY_TABLE_ITERATOR;
- 
- typedef struct buffer_type                BUFFER;
- 
  typedef struct script_set_data            SCRIPT_SET;
  typedef struct edesc_data                 EDESC_DATA;
  typedef struct edesc_set_data             EDESC_SET;
--- 47,56 ----
***************
*** 73,79 ****
  typedef struct shop_data                  SHOP_DATA;
  typedef struct body_data                  BODY_DATA;
  typedef struct reset_data                 RESET_DATA;
- typedef struct olc_data                   OLC_DATA;
  
  typedef int                               shop_vnum;
  typedef int                               room_vnum;
--- 66,71 ----
***************
*** 98,113 ****
  // the typedefs.
  #include "property_table.h"
  #include "list.h"
! #include "hashmap.h"
  #include "hashtable.h"
  #include "set.h"
  
  
  
! 
! /************************
!  * Standard definitions *
!  ************************/
  
  /* define TRUE and FALSE */
  #ifndef FALSE
--- 90,106 ----
  // the typedefs.
  #include "property_table.h"
  #include "list.h"
! #include "map.h"
  #include "hashtable.h"
  #include "set.h"
+ #include "buffer.h"
+ #include "bitvector.h"
  
  
  
! //*****************************************************************************
! // Standard definitions
! //*****************************************************************************
  
  /* define TRUE and FALSE */
  #ifndef FALSE
***************
*** 132,138 ****
  #define MAX_SCRIPT         16384                  /* max length of a script */
  #define MAX_OUTPUT         8192                   /* well shoot me if it isn't enough   */
  #define FILE_TERMINATOR    "EOF"                  /* end of file marker                 */
! #define COPYOVER_FILE      "../txt/copyover.dat"  /* tempfile to store copyover data    */
  #define EXE_FILE           "../src/NakedMud"      /* the name of the mud binary         */
  #define DEFAULT_PORT       4000                   /* the default port we run on */
  
--- 125,131 ----
  #define MAX_SCRIPT         16384                  /* max length of a script */
  #define MAX_OUTPUT         8192                   /* well shoot me if it isn't enough   */
  #define FILE_TERMINATOR    "EOF"                  /* end of file marker                 */
! #define COPYOVER_FILE      "../.copyover.dat"     /* tempfile to store copyover data    */
  #define EXE_FILE           "../src/NakedMud"      /* the name of the mud binary         */
  #define DEFAULT_PORT       4000                   /* the default port we run on */
  
***************
*** 142,161 ****
  // this line
  //#define MUD_THREADABLE
  
- /* Connection States */
- #define STATE_CLOSED           0  /* should always be the last state
-                                      The above comment is incorrect. GH */
- #define STATE_PLAYING          1
- #define STATE_OLC              2
- #define STATE_TEXT_EDITOR      3 
- #define STATE_NEW_NAME         4
- #define STATE_NEW_PASSWORD     5
- #define STATE_VERIFY_PASSWORD  6
- #define STATE_ASK_PASSWORD     7
- #define STATE_ASK_SEX          8
- #define STATE_ASK_RACE         9
- 
- 
  /* Thread States */
  #define TSTATE_LOOKUP          0  /* Socket is in host_lookup        */
  #define TSTATE_DONE            1  /* The lookup is done.             */
--- 135,140 ----
***************
*** 188,204 ****
  
  #define WORLD_PATH     "../lib/world"
  
- /******************************
-  * End of standard definitons *
-  ******************************/
- 
  
  
! /******************************
!  * New structures             *
!  ******************************/
  
! /* the actual structures */
  struct lookup_data
  {
    SOCKET_DATA       * dsock;   /* the socket we wish to do a hostlookup on */
--- 167,179 ----
  
  #define WORLD_PATH     "../lib/world"
  
  
  
! //*****************************************************************************
! // New structures
! //*****************************************************************************
  
! // required for looking up a socket's IP in a new thread
  struct lookup_data
  {
    SOCKET_DATA       * dsock;   /* the socket we wish to do a hostlookup on */
***************
*** 206,211 ****
--- 181,190 ----
  };
  
  
+ 
+ //*****************************************************************************
+ // core functions for working with new commands
+ //*****************************************************************************
  #define CMD_PTR(name)      void (* name)(CHAR_DATA *ch, const char *cmd, \
  					 int subcmd, char *arg)
  #define COMMAND(name)      void name(CHAR_DATA *ch, const char *cmd, \
***************
*** 216,247 ****
  void add_cmd      (const char *cmd, const char *sort_by, void *func, 
  	           int subcmd, int min_pos, int max_pos,
  	           int min_level, bool mob_ok, bool interrupts);
! void remove_cmd   (const char *cmd);
! 
! 
! struct buffer_type
! {
!   char   * data;        /* The data                      */
!   int      len;         /* The current len of the buffer */
!   int      size;        /* The allocated size of data    */
! };
! 
! /******************************
!  * End of new structures      *
!  ******************************/
  
  
  
! /***************************
!  * Global Variables        *
!  ***************************/
! 
  extern  LIST           *object_list;
  extern  PROPERTY_TABLE *obj_table;      /* same contents as object_list, but
  					   arranged by uid (unique ID)        */
  extern  LIST           *socket_list;
- extern  LIST           *socket_free;
  extern  LIST           *mobile_list;
  extern  PROPERTY_TABLE *mob_table;      /* same contents as mobile_list, but
  					   arranged by uid (unique ID)        */
  extern  const struct    typCmd tabCmd[];/* the command table                  */
--- 195,214 ----
  void add_cmd      (const char *cmd, const char *sort_by, void *func, 
  	           int subcmd, int min_pos, int max_pos,
  	           int min_level, bool mob_ok, bool interrupts);
! bool cmd_exists   (const char *cmd);
  
  
  
! //*****************************************************************************
! // Global Variables
! //*****************************************************************************
  extern  LIST           *object_list;
  extern  PROPERTY_TABLE *obj_table;      /* same contents as object_list, but
  					   arranged by uid (unique ID)        */
  extern  LIST           *socket_list;
  extern  LIST           *mobile_list;
+ extern  LIST           *extract_obj_funcs; // functions called on obj extraction
+ extern  LIST           *extract_mob_funcs; // functions called on mob extraction
  extern  PROPERTY_TABLE *mob_table;      /* same contents as mobile_list, but
  					   arranged by uid (unique ID)        */
  extern  const struct    typCmd tabCmd[];/* the command table                  */
***************
*** 254,269 ****
  
  extern WORLD_DATA    *   gameworld;     // the world of the game
  
- /*************************** 
-  * End of Global Variables *
-  ***************************/
- 
- 
  
- /***********************
-  *    MCCP support     *
-  ***********************/
  
  extern const unsigned char compress_will[];
  extern const unsigned char compress_will2[];
  
--- 221,231 ----
  
  extern WORLD_DATA    *   gameworld;     // the world of the game
  
  
  
+ //*****************************************************************************
+ // MCCP support
+ //*****************************************************************************
  extern const unsigned char compress_will[];
  extern const unsigned char compress_will2[];
  
***************
*** 271,289 ****
  #define TELOPT_COMPRESS2      86
  #define COMPRESS_BUF_SIZE   8192
  
- /***********************
-  * End of MCCP support *
-  ***********************/
- 
- 
- 
- /***********************************
-  * Prototype function declerations *
-  ***********************************/
  
- #define  buffer_new(size)             __buffer_new     ( size)
- #define  buffer_strcat(buffer,text)   __buffer_strcat  ( buffer, text )
  
  char  *crypt                  ( const char *key, const char *salt );
  
  
--- 233,243 ----
  #define TELOPT_COMPRESS2      86
  #define COMPRESS_BUF_SIZE   8192
  
  
  
+ //*****************************************************************************
+ // Prototype function declerations
+ //*****************************************************************************
  char  *crypt                  ( const char *key, const char *salt );
  
  
***************
*** 294,300 ****
  // Some command scripts may want to re-force a character to
  // perform the command. In that case, scripts_ok can be
  // set to FALSE so that the command script doesn't re-run
- //
  void  do_cmd                  ( CHAR_DATA *ch, char *arg, 
  				bool scripts_ok, bool aliases_ok);
  
--- 248,253 ----
***************
*** 310,327 ****
  
  /* strings.c */
  char   *one_arg               ( char *fStr, char *bStr );
  void    arg_num               ( const char *from, char *to, int num); 
  bool    compares              ( const char *aStr, const char *bStr );
  bool    is_prefix             ( const char *aStr, const char *bStr );
  char   *capitalize            ( char *txt );
  char   *strfind               (char *txt, char *sub);
- BUFFER *__buffer_new          ( int size );
- void    __buffer_strcat       ( BUFFER *buffer, const char *text );
- void    buffer_free           ( BUFFER *buffer );
- void    buffer_clear          ( BUFFER *buffer );
- int     bprintf               ( BUFFER *buffer, char *fmt, ... ) __attribute__ ((format (printf, 2, 3)));
- const char *buffer_string     ( BUFFER *buffer );
- void    buffer_format         ( BUFFER *buffer, bool indent );
  
  /* mccp.c */
  bool  compressStart     ( SOCKET_DATA *dsock, unsigned char teleopt );
--- 263,274 ----
  
  /* strings.c */
  char   *one_arg               ( char *fStr, char *bStr );
+ char   *two_args              ( char *from, char *arg1, char *arg2);
  void    arg_num               ( const char *from, char *to, int num); 
  bool    compares              ( const char *aStr, const char *bStr );
  bool    is_prefix             ( const char *aStr, const char *bStr );
  char   *capitalize            ( char *txt );
  char   *strfind               (char *txt, char *sub);
  
  /* mccp.c */
  bool  compressStart     ( SOCKET_DATA *dsock, unsigned char teleopt );
***************
*** 338,346 ****
  void  page_continue         ( SOCKET_DATA *dsock);
  void  page_back             ( SOCKET_DATA *dsock);
  
- 
- /*******************************
-  * End of prototype declartion *
-  *******************************/
- 
  #endif  /* MUD_H */
--- 285,288 ----
diff -crN nakedmudv1.5/src/object.c nakedmudv2.0/src/object.c
*** nakedmudv1.5/src/object.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/object.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 14,20 ****
  #include "mud.h"
  #include "extra_descs.h"
  #include "utils.h"
- #include "items.h"
  #include "body.h"
  #include "handler.h"
  #include "storage.h"
--- 14,19 ----
***************
*** 29,48 ****
  
  struct object_data {
    obj_vnum vnum;                 // our number for builders
!   int type, subtype;             // e.g. clothing/shirt
!   int         uid;               // our unique identifier
!   bitvector_t bits;              // bits that have to do with our current state
!   double      weight;            // how much do we weigh, minus contents
!   double      capacity;          // how much weight can we hold?
! 
!   int values[NUM_OBJ_VALUES];    // special values used by items.h
    
    char *name;                    // our name - e.g. "a shirt"
    char *keywords;                // words to reference us by
    char *rdesc;                   // our room description
-   char *desc;                    // the description when we are looked at
    char *multi_name;              // our name when more than 1 appears
    char *multi_rdesc;             // our rdesc when more than 1 appears
  
    // only one of these should be set at a time
    OBJ_DATA  *container;          // the thing we are in
--- 28,43 ----
  
  struct object_data {
    obj_vnum vnum;                 // our number for builders
!   int      uid;                  // our unique identifier
!   double   weight;               // how much do we weigh, minus contents
    
    char *name;                    // our name - e.g. "a shirt"
    char *keywords;                // words to reference us by
    char *rdesc;                   // our room description
    char *multi_name;              // our name when more than 1 appears
    char *multi_rdesc;             // our rdesc when more than 1 appears
+   BUFFER *desc;                  // the description when we are looked at
+   BITVECTOR *bits;               // the object bits we have turned on
  
    // only one of these should be set at a time
    OBJ_DATA  *container;          // the thing we are in
***************
*** 65,82 ****
    obj->uid            = next_obj_uid++;
    obj->vnum           = NOTHING;
  
-   obj->type           = ITEM_OTHER;
-   obj->subtype        = 0;
-   obj->bits           = 0;
    obj->weight         = 0.1;
-   obj->capacity       = 0;
  
    obj->name           = strdup("");
    obj->keywords       = strdup("");
    obj->rdesc          = strdup("");
-   obj->desc           = strdup("");
    obj->multi_name     = strdup("");
    obj->multi_rdesc    = strdup("");
  
    obj->contents       = newList();
    obj->users          = newList();
--- 60,74 ----
    obj->uid            = next_obj_uid++;
    obj->vnum           = NOTHING;
  
    obj->weight         = 0.1;
  
+   obj->bits           = bitvectorInstanceOf("obj_bits");
    obj->name           = strdup("");
    obj->keywords       = strdup("");
    obj->rdesc          = strdup("");
    obj->multi_name     = strdup("");
    obj->multi_rdesc    = strdup("");
+   obj->desc           = newBuffer(1);
  
    obj->contents       = newList();
    obj->users          = newList();
***************
*** 98,107 ****
    if(obj->name)       free(obj->name);
    if(obj->keywords)   free(obj->keywords);
    if(obj->rdesc)      free(obj->rdesc);
!   if(obj->desc)       free(obj->desc);
    if(obj->multi_name) free(obj->multi_name);
    if(obj->multi_rdesc)free(obj->multi_rdesc);
! 
    if(obj->edescs)   deleteEdescSet(obj->edescs);
    deleteAuxiliaryData(obj->auxiliary_data);
  
--- 90,99 ----
    if(obj->name)       free(obj->name);
    if(obj->keywords)   free(obj->keywords);
    if(obj->rdesc)      free(obj->rdesc);
!   if(obj->desc)       deleteBuffer(obj->desc);
    if(obj->multi_name) free(obj->multi_name);
    if(obj->multi_rdesc)free(obj->multi_rdesc);
!   if(obj->bits)     deleteBitvector(obj->bits);
    if(obj->edescs)   deleteEdescSet(obj->edescs);
    deleteAuxiliaryData(obj->auxiliary_data);
  
***************
*** 110,134 ****
  
  
  OBJ_DATA *objRead(STORAGE_SET *set) {
!   OBJ_DATA *obj = newObj(NOTHING);
    objSetVnum(obj,               read_int(set, "vnum"));
-   objSetType(obj,               read_int(set, "type"));
-   objSetSubtype(obj,            read_int(set, "subtype"));
-   objSetVal(obj, 0,             read_int(set, "value 0"));
-   objSetVal(obj, 1,             read_int(set, "value 1"));
-   objSetVal(obj, 2,             read_int(set, "value 2"));
-   objSetVal(obj, 3,             read_int(set, "value 3"));
-   objSetVal(obj, 4,             read_int(set, "value 4"));
    objSetWeightRaw(obj,       read_double(set, "weight"));
-   objSetCapacity(obj,        read_double(set, "capacity"));
    objSetName(obj,            read_string(set, "name"));
    objSetKeywords(obj,        read_string(set, "keywords"));
    objSetRdesc(obj,           read_string(set, "rdesc"));
    objSetDesc(obj,            read_string(set, "desc"));
    objSetMultiName(obj,       read_string(set, "multiname"));
    objSetMultiRdesc(obj,      read_string(set, "multirdesc"));
-   obj->bits =     parse_bits(read_string(set, "bits"));
    objSetEdescs(obj,   edescSetRead(read_set(set, "edescs")));
    deleteAuxiliaryData(obj->auxiliary_data);
    obj->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
  					  AUXILIARY_TYPE_OBJ);
--- 102,118 ----
  
  
  OBJ_DATA *objRead(STORAGE_SET *set) {
!   OBJ_DATA *obj = newObj();
    objSetVnum(obj,               read_int(set, "vnum"));
    objSetWeightRaw(obj,       read_double(set, "weight"));
    objSetName(obj,            read_string(set, "name"));
    objSetKeywords(obj,        read_string(set, "keywords"));
    objSetRdesc(obj,           read_string(set, "rdesc"));
    objSetDesc(obj,            read_string(set, "desc"));
    objSetMultiName(obj,       read_string(set, "multiname"));
    objSetMultiRdesc(obj,      read_string(set, "multirdesc"));
    objSetEdescs(obj,   edescSetRead(read_set(set, "edescs")));
+   bitSet(obj->bits,read_string(set, "obj_bits"));
    deleteAuxiliaryData(obj->auxiliary_data);
    obj->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
  					  AUXILIARY_TYPE_OBJ);
***************
*** 149,185 ****
  STORAGE_SET *objStore(OBJ_DATA *obj) {
    STORAGE_SET *set = new_storage_set();
    store_int   (set, "vnum",      obj->vnum);
-   store_int   (set, "type",      obj->type);
-   store_int   (set, "subtype",   obj->subtype);
-   store_int   (set, "value 0",   objGetVal(obj, 0));
-   store_int   (set, "value 1",   objGetVal(obj, 1));
-   store_int   (set, "value 2",   objGetVal(obj, 2));
-   store_int   (set, "value 3",   objGetVal(obj, 3));
-   store_int   (set, "value 4",   objGetVal(obj, 4));
    store_double(set, "weight",    obj->weight);
-   store_double(set, "capacity",  obj->capacity);
    store_string(set, "name",      obj->name);
    store_string(set, "keywords",  obj->keywords);
    store_string(set, "rdesc",     obj->rdesc);
!   store_string(set, "desc",      obj->desc);
    store_string(set, "multiname", obj->multi_name);
    store_string(set, "multirdesc",obj->multi_rdesc);
-   store_string(set, "bits",      write_bits(obj->bits));
    store_set   (set, "edescs",    edescSetStore(obj->edescs));
    store_set   (set, "auxiliary", auxiliaryDataStore(obj->auxiliary_data));
    store_list  (set, "contents",  gen_store_list(obj->contents, objStore));
    return set;
  }
  
  
  void objCopyTo(OBJ_DATA *from, OBJ_DATA *to) {
-   int i;
-   for(i = 0; i < NUM_OBJ_VALUES; i++)
-     objSetVal(to, i, objGetVal(from, i));
- 
-   to->bits = from->bits;
- 
-   objSetCapacity  (to, objGetCapacity(from));
    objSetWeightRaw (to, objGetWeightRaw(from));
    objSetVnum      (to, objGetVnum(from));
    objSetName      (to, objGetName(from));
--- 133,155 ----
  STORAGE_SET *objStore(OBJ_DATA *obj) {
    STORAGE_SET *set = new_storage_set();
    store_int   (set, "vnum",      obj->vnum);
    store_double(set, "weight",    obj->weight);
    store_string(set, "name",      obj->name);
    store_string(set, "keywords",  obj->keywords);
    store_string(set, "rdesc",     obj->rdesc);
!   store_string(set, "desc",      bufferString(obj->desc));
    store_string(set, "multiname", obj->multi_name);
    store_string(set, "multirdesc",obj->multi_rdesc);
    store_set   (set, "edescs",    edescSetStore(obj->edescs));
+   store_string(set, "obj_bits",  bitvectorGetBits(obj->bits));
    store_set   (set, "auxiliary", auxiliaryDataStore(obj->auxiliary_data));
    store_list  (set, "contents",  gen_store_list(obj->contents, objStore));
+ 
    return set;
  }
  
  
  void objCopyTo(OBJ_DATA *from, OBJ_DATA *to) {
    objSetWeightRaw (to, objGetWeightRaw(from));
    objSetVnum      (to, objGetVnum(from));
    objSetName      (to, objGetName(from));
***************
*** 188,207 ****
    objSetDesc      (to, objGetDesc(from));
    objSetMultiName (to, objGetMultiName(from));
    objSetMultiRdesc(to, objGetMultiRdesc(from));
!   objSetType     (to, objGetType(from));
!   objSetSubtype  (to, objGetSubtype(from));
!   copyEdescSetTo (objGetEdescs(from), objGetEdescs(to));
    auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
  }
  
- 
  OBJ_DATA *objCopy(OBJ_DATA *obj) {
    OBJ_DATA *newobj = newObj();
    objCopyTo(obj, newobj);
    return newobj;
  }
  
- 
  bool objIsName(OBJ_DATA *obj, const char *name) {
    return is_keyword(obj->keywords, name, TRUE);
  }
--- 158,174 ----
    objSetDesc      (to, objGetDesc(from));
    objSetMultiName (to, objGetMultiName(from));
    objSetMultiRdesc(to, objGetMultiRdesc(from));
!   edescSetCopyTo  (objGetEdescs(from), objGetEdescs(to));
!   bitvectorCopyTo (from->bits, to->bits);
    auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
  }
  
  OBJ_DATA *objCopy(OBJ_DATA *obj) {
    OBJ_DATA *newobj = newObj();
    objCopyTo(obj, newobj);
    return newobj;
  }
  
  bool objIsName(OBJ_DATA *obj, const char *name) {
    return is_keyword(obj->keywords, name, TRUE);
  }
***************
*** 211,222 ****
    listPut(obj->users, ch);
  }
  
- 
  void objRemoveChar(OBJ_DATA *obj, CHAR_DATA *ch) {
    listRemove(obj->users, ch);
  }
  
  
  //*****************************************************************************
  //
  // set and get functions
--- 178,189 ----
    listPut(obj->users, ch);
  }
  
  void objRemoveChar(OBJ_DATA *obj, CHAR_DATA *ch) {
    listRemove(obj->users, ch);
  }
  
  
+ 
  //*****************************************************************************
  //
  // set and get functions
***************
*** 234,251 ****
    return obj->vnum;
  }
  
- int objGetVal(OBJ_DATA *obj, int num) {
-   return obj->values[num];
- }
- 
- int objGetType(OBJ_DATA *obj) {
-   return obj->type;
- }
- 
- int objGetSubtype(OBJ_DATA *obj) {
-   return obj->subtype;
- }
- 
  const char *objGetName(OBJ_DATA *obj) {
    return obj->name;
  }
--- 201,206 ----
***************
*** 259,277 ****
  }
  
  const char  *objGetDesc    (OBJ_DATA *obj) {
!   return obj->desc;
  }
  
  const char  *objGetMultiName(OBJ_DATA *obj) {
    return obj->multi_name;
  }
  
! const char  *objGetMultiRdesc(OBJ_DATA *obj) {
!   return obj->multi_rdesc;
  }
  
! char **objGetDescPtr(OBJ_DATA *obj) {
!   return &(obj->desc);
  }
  
  EDESC_SET *objGetEdescs(OBJ_DATA *obj) {
--- 214,232 ----
  }
  
  const char  *objGetDesc    (OBJ_DATA *obj) {
!   return bufferString(obj->desc);
  }
  
  const char  *objGetMultiName(OBJ_DATA *obj) {
    return obj->multi_name;
  }
  
! BUFFER *objGetDescBuffer(OBJ_DATA *obj) {
!   return obj->desc;
  }
  
! const char  *objGetMultiRdesc(OBJ_DATA *obj) {
!   return obj->multi_rdesc;
  }
  
  EDESC_SET *objGetEdescs(OBJ_DATA *obj) {
***************
*** 279,286 ****
  }
  
  const char *objGetEdesc(OBJ_DATA *obj, const char *keyword) {
!   EDESC_DATA *edesc = getEdesc(obj->edescs, keyword);
!   if(edesc) return getEdescDescription(edesc);
    else return NULL;
  }
  
--- 234,241 ----
  }
  
  const char *objGetEdesc(OBJ_DATA *obj, const char *keyword) {
!   EDESC_DATA *edesc = edescSetGet(obj->edescs, keyword);
!   if(edesc) return edescSetGetDesc(edesc);
    else return NULL;
  }
  
***************
*** 304,313 ****
    return obj->uid;
  }
  
- double objGetCapacity(OBJ_DATA *obj) {
-   return obj->capacity;
- }
- 
  double objGetWeightRaw(OBJ_DATA *obj) {
    return obj->weight;
  }
--- 259,264 ----
***************
*** 325,330 ****
--- 276,285 ----
    return tot_weight;
  }
  
+ BITVECTOR *objGetBits(OBJ_DATA *obj) {
+   return obj->bits;
+ }
+ 
  void *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name) {
    return hashGet(obj->auxiliary_data, name);
  }
***************
*** 333,355 ****
    obj->vnum = vnum;
  }
  
- void objSetVal(OBJ_DATA *obj, int num, int val) {
-   obj->values[num] = val;
- }
- 
- void objSetType(OBJ_DATA *obj, int type) {
-   obj->type = type;
- }
- 
- void objSetSubtype(OBJ_DATA *obj, int subtype) {
-   obj->subtype = subtype;
- }
- 
- void objSetName(OBJ_DATA *obj, const char *name) {
-   if(obj->name) free(obj->name);
-   obj->name = strdup(name ? name : "");
- }
- 
  void objSetKeywords(OBJ_DATA *obj, const char *keywords) {
    if(obj->keywords) free(obj->keywords);
    obj->keywords = strdup(keywords ? keywords : "");
--- 288,293 ----
***************
*** 360,368 ****
    obj->rdesc = strdup(rdesc ? rdesc : "");
  }
  
  void objSetDesc(OBJ_DATA *obj, const char *desc) {
!   if(obj->desc) free(obj->desc);
!   obj->desc = strdup(desc ? desc : "");
  }
  
  void objSetMultiName(OBJ_DATA *obj, const char *multi_name) {
--- 298,311 ----
    obj->rdesc = strdup(rdesc ? rdesc : "");
  }
  
+ void objSetName(OBJ_DATA *obj, const char *name) {
+   if(obj->name) free(obj->name);
+   obj->name = strdup(name ? name : "");
+ }
+ 
  void objSetDesc(OBJ_DATA *obj, const char *desc) {
!   bufferClear(obj->desc);
!   bufferCat(obj->desc, (desc ? desc : ""));
  }
  
  void objSetMultiName(OBJ_DATA *obj, const char *multi_name) {
***************
*** 396,451 ****
    obj->room = room;
  }
  
- void objSetCapacity(OBJ_DATA *obj, double capacity) {
-   obj->capacity = capacity;
- }
- 
  void objSetWeightRaw(OBJ_DATA *obj, double weight) {
    obj->weight = weight;
  }
- 
- 
- 
- //*****************************************************************************
- //
- // object bits
- //
- //*****************************************************************************
- 
- const char *obj_bits[NUM_OBJ_BITS] = {
-   "notake"
- };
- 
- const char  *objBitGetName    (int field, int bit) {
-   if(field == BITFIELD_OBJ)
-     return obj_bits[bit];
-   return NULL;
- }
- 
- void         objSetBit       ( OBJ_DATA *obj, int field, int bit) {
-   if(field == BITFIELD_OBJ)
-     SET_BIT(obj->bits, (1 << bit));
- }
- 
- void         objRemoveBit    ( OBJ_DATA *obj, int field, int bit) {
-   if(field == BITFIELD_OBJ)
-     REMOVE_BIT(obj->bits, (1 << bit));
- }
- 
- void         objToggleBit    ( OBJ_DATA *obj, int field, int bit) {
-   if(field == BITFIELD_OBJ)
-     TOGGLE_BIT(obj->bits, (1 << bit));
- }
- 
- bool         objIsBitSet     ( OBJ_DATA *obj, int field, int bit) {
-   if(field == BITFIELD_OBJ && IS_SET(obj->bits, (1 << bit)))
-     return TRUE;
-   return FALSE;
- }
- 
- void         objPrintBits   ( OBJ_DATA *obj, int field, char *buf) {
-   if(field == BITFIELD_OBJ)
-     print_bits(obj->bits, obj_bits, buf);
-   else
-     *buf = '\0';
- }
--- 339,344 ----
diff -crN nakedmudv1.5/src/object.d nakedmudv2.0/src/object.d
*** nakedmudv1.5/src/object.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/object.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ object.d object.o: object.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h extra_descs.h utils.h body.h \
+   handler.h storage.h auxiliary.h object.h
